#!/bin/bash

source "./config"

###############################################################################

PATCHDIR=`pwd`

if [ ! -f ${PATCHDIR}/.patch_applied ]
then
	echo "Applying AIR patch..."
	cp -ur ${PATCHDIR}/libair ${PATCHDIR}/libconstraint ${GCCDIR}
	cd ${GCCDIR} && patch -p0 -i ${PATCHDIR}/air-patch*.diff
	touch ${PATCHDIR}/.patch_applied
fi

echo "Configuring GCC..."
cd ${GCCDIR} && ./configure --enable-languages=c --with-pkgversion="AIR 2.0" --enable-checking=release --prefix=${INSTALLDIR}

echo "Compiling GCC..."
cd ${GCCDIR} && make && make install

echo "Compiling libconstraint..."
cd ${GCCDIR}/libconstraint && make PATCHDIR=${PATCHDIR}

if [ -f ${INCLUDEDIR}/stdlib.h ]
then
	echo "You seem to already have a stdlib.h in the install path... if it is not TR2473-1 compliant, please consider replacing it with the supplied stdlib.h"
else
	echo "Installing custom stdlib.h..."
	if [ ! -d ${INCLUDEDIR} ]
	then
		mkdir -p ${INCLUDEDIR} && cp ${PATCHDIR}/include/stdlib.h ${INCLUDEDIR}/stdlib.h
	fi
fi
