/**
 * Copyright (c) 2009 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use this software and its documentation for any purpose is
 * hereby granted, provided that the above copyright notice appear and that
 * both that copyright notice and this permission notice appear in supporting
 * documentation, and that the name of CMU not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WSTRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL CMU BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, RISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * GCC is free software; you can redistribute it and/or modify it under|
 * the terms of the GNU General Public License as published by the Free|
 * Software Foundation; either version 3, or (at your option) any later|
 * version.|
 * |
 * GCC is distributed in the hope that it will be useful, but WITHOUT ANY|
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or|
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License|
 * for more details.|
 * |
 * You should have received a copy of the GNU General Public License|
 * along with GCC; see the file COPYING3.  If not see|
 * <http://www.gnu.org/licenses/>.
 */


#ifndef AIR_H
#define AIR_H

extern void air_add_1(rtx insn, rtx *operands, const char *suffix);
extern void air_add_2(rtx insn, rtx *operands, const char *suffix);
extern void air_mul3_1(rtx *operands, const char *suffix);
extern void air_negsi2_1(rtx *operands);
extern void air_ashlsi3_1(rtx insn, rtx *operands);
extern void air_add3_carry(rtx *operands, const char *suffix);
extern void air_sub_1(rtx *operands, const char *suffix);

extern unsigned int air_merge_signs (rtx op0, rtx op1);
extern void air_set_sign1 (unsigned int unsignedp, rtx op0);
extern void air_set_sign2 (unsigned int unsignedp, rtx op0, rtx op1);
extern void air_set_sign3 (unsigned int unsignedp, rtx op0, rtx op1, rtx op2);
extern void air_set_sign4 (unsigned int unsignedp, rtx op0, rtx op1, rtx op2, rtx op3);
extern void air_copy_sign (rtx new_rtx, rtx old_rtx);
extern void air_copy_whitelisted (rtx new_rtx, rtx old_rtx);
extern void air_set_sign_direct (unsigned int sign, rtx op0);
extern void air_whitelist_rtx (rtx op0);
extern void air_emit_truncation_checks(unsigned int to_sign, enum machine_mode to_mode,
    rtx from, unsigned int unsignedp, enum machine_mode from_mode);
extern unsigned int  air_get_tree_sign(tree op0, tree op1);

extern void *air_handle;

extern void air_convert_move (rtx to, rtx from, int unsignedp, unsigned int to_sign);
extern void init_whitelist (const char *file_name);
extern bool whitelisted_location_p (const char *file, unsigned int line);
extern void air_whitelist_expr (tree exp);
#endif
