/**
 * Copyright (c) 2009 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use this software and its documentation for any purpose is
 * hereby granted, provided that the above copyright notice appear and that
 * both that copyright notice and this permission notice appear in supporting
 * documentation, and that the name of CMU not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WSTRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL CMU BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, RISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * GCC is free software; you can redistribute it and/or modify it under|
 * the terms of the GNU General Public License as published by the Free|
 * Software Foundation; either version 3, or (at your option) any later|
 * version.|
 * |
 * GCC is distributed in the hope that it will be useful, but WITHOUT ANY|
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or|
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License|
 * for more details.|
 * |
 * You should have received a copy of the GNU General Public License|
 * along with GCC; see the file COPYING3.  If not see|
 * <http://www.gnu.org/licenses/>.
 */

#include <constraint_asm.h>

constraint_handler_wrapper(add,1);
constraint_handler_wrapper(sub,2);
constraint_handler_wrapper(mul,3);
constraint_handler_wrapper(sal,4);
constraint_handler_wrapper(inc,5);
constraint_handler_wrapper(dec,6);
constraint_handler_wrapper(neg,7);

.global constraint_handler_wrapper_trunc
    .type constraint_handler_wrapper_trunc, @function

constraint_handler_wrapper_trunc:
        pusha
        pushl $8
        pushl $0
        pushl   0x28(%esp)
        call constraint_handler_wrapper_inner
        addl    $0xc, %esp
        popa
        ret
    .size    constraint_handler_wrapper_trunc, .-constraint_handler_wrapper_trunc

.globl shift_overflow_masks
  .data
  .align 4
  .type shift_overflow_masks, @object
  .size shift_overrlow_masks, 16
shift_overflow_masks:
  .long 0x80000000
  .long 0xc0000000
  .long 0xe0000000
  .long 0xf0000000
  .text

