/**
 * Copyright (c) 2009 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use this software and its documentation for any purpose is
 * hereby granted, provided that the above copyright notice appear and that
 * both that copyright notice and this permission notice appear in supporting
 * documentation, and that the name of CMU not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WSTRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL CMU BE
 * LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, RISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * GCC is free software; you can redistribute it and/or modify it under|
 * the terms of the GNU General Public License as published by the Free|
 * Software Foundation; either version 3, or (at your option) any later|
 * version.|
 * |
 * GCC is distributed in the hope that it will be useful, but WITHOUT ANY|
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or|
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License|
 * for more details.|
 * |
 * You should have received a copy of the GNU General Public License|
 * along with GCC; see the file COPYING3.  If not see|
 * <http://www.gnu.org/licenses/>.
 */

#ifndef CONSTRAINT_ASM_H
#define CONSTRAINT_ASM_H

#define constraint_handler_wrapper_sign(name, sign, typ)     \
.global constraint_handler_wrapper_## name                  ;\
    .type constraint_handler_wrapper_## name ##, @function  ;\
                                                            ;\
constraint_handler_wrapper_## name ##:                      ;\
        pushf                                               ;\
        pusha                                               ;\
        pushl   $##typ                                      ;\
        pushl   $##sign                                     ;\
        pushl   0x2c(%esp)                                  ;\
        call constraint_handler_wrapper_inner               ;\
        addl    $0xc, %esp                                  ;\
        popa                                                ;\
        popf                                                ;\
        ret                                                 ;\
    .size    constraint_handler_wrapper_##name##, .-constraint_handler_wrapper_##name;


#define constraint_handler_wrapper(name, type)\
constraint_handler_wrapper_sign(u##name##,2, type)\
constraint_handler_wrapper_sign(s##name##,1, type)

#endif
