#!/usr/bin/perl
# 
# Copyright (c) 2009 Carnegie Mellon University.
# All rights reserved.
#
# Permission to use this software and its documentation for any purpose is
# hereby granted, provided that the above copyright notice appear and that
# both that copyright notice and this permission notice appear in supporting
# documentation, and that the name of CMU not be used in advertising or
# publicity pertaining to distribution of the software without specific,
# written prior permission.
#
# CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
# IMPLIED WSTRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL CMU BE
# LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, RISING OUT OF OR
# IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

# Given the location of the program and a file containing the output of the
# constraint handler, output source code lines responsible for those errors.
# Used in conjunction with catch-vuls.pl to produce the error file.
#
# Sample usage: ./print-vuls.pl PROG < ERROR_FILE

$prog = shift;

while (<STDIN>) {
  $_ =~ /([0-9a-f]{7,8}) (.*)/i;
  @info = `addr2line -fe $prog $1`;
  if ($info[0] ne $prevfunc) {
    print "\n\n$info[0]";
  }

  if ($info[1] ne $prevfile) {
    print "$info[1]";
  }
  
  print "0x$_";

  $prevfunc = $info[0];
  $prevfile = $info[1];
}
